graph:
  id: test
  description: Dynamic tree split of long text into chunks for parallel summarization.
  log_level: DEBUG
  is_majority_voting: false
  nodes:
    - id: A
      type: literal
      config:
        content: |-
          ## Being God, Being Human
          >In the deep night of the planet Arrakis, Paul Muad'Dib had a terrible precognitive dream—
          >His jihad would slaughter ninety billion souls, the entire universe would bleed in his name;
          >Even more terrifyingly, in his vision, his beloved Chani cursed him with tears streaming down her face:
          >“You chose to become a god, but forgot how to be a human.”
          >After waking up in terror, Paul resolutely abandoned all spice, gave up all his precognitive powers,
          >and became an ordinary spice hauler, living a simple life with Chani in the desert.
          >However, the trackers of destiny were already closing in, and a greater crisis was brewing in the shadows...

          ---

          Sand, always sand. The grains of Arrakis, under the cool glow of the twin moons, looked like countless shattered silver coins, spreading to the end of the horizon, meeting the sky filled with unfamiliar constellations. The wind was the only eternal singer here, whispering as it kicked up dust, carving new lines into the jagged rocks.

          Between this endless silver sand and the deep blue night sky, Paul Muad'Dib—or the one who used to be Paul—snapped upright, his movement so violent it nearly threw off the thin survival blanket that protected him from the nocturnal chill.

          Cold sweat didn't come from the desert night's temperature, but seeped from every pore, instantly drenching his coarse cotton undershirt. His heart hammered wildly in his chest, like a trapped beast slamming against the cage of his ribs. He gasped for air, the dry wind scraping his throat, bringing sting, but unable to disperse the image that sat in his mind, more gruesome than any real fear.

          Blood. Not a drop, not a puddle, but a sea of blood that swallowed stars and covered galaxies. Ninety billion... the cries of ninety billion souls merged into the background noise of the universe, their faces floating and shattering in the waves of blood. Every single one pointed at him. Every fading conscious spark called the same name—Muad'Dib. It was him, his banner, his jihad. The golden griffin emblem flew over mountains of corpses, blindingly bright.

          Then, at the center of that crimson expanse, she appeared.

          Chani.

          She stood there, with burning planets and capsized fleets in the background. The sand couldn't erode her clear silhouette; those eyes he had so often been lost in, clear as a desert oasis, were now filled with broken stars and bottomless pain. Tears silently slid down her dust-stained cheeks, leaving winding tracks.

          Her lips moved, her voice wasn't loud, but it was like a cold dagger dipped in desperate poison, accurately piercing the deepest part of his soul.

          “You chose to become a god,” her voice was terrifyingly calm, every word carrying a ton of weight, “but forgot how to be a human.”

          That look wasn't love anymore, not even understanding, but... a curse.

          “No...” A raspy sound squeezed from Paul's throat, so weak it was instantly swallowed by the wind. He instinctively reached out to his side, his fingertips touching a patch of warm, real skin.

          Chani lay sleeping beside him, wrapped in another survival blanket, her breathing steady, her chest rising and falling gently. Her face looked peaceful and serene in the moonlight, a world apart from the tear-streaked version in his dream.

          The real touch pulled back his drifting consciousness. He withdrew his hand, tightly clutching a handful of sand beneath him. The sand was coarse and cold, with the unique texture of Arrakis. Real. This was real.

          He looked around. They were sheltered under a small rock overhang, a survival wisdom passed down through generations of Fremen. Not far away sat their old spice harvester, like a clunky giant beast napping in the moonlight. Several bags of collected spice—the priceless melange that could extend consciousness and open visions of the future—were piled haphazardly to the side. These were the things, this golden spice, that had pushed him onto that destined path toward the throne and the sea of blood.

          A strong, almost instinctive revulsion welled up in him. It was this! It was what made him see that singular, terrifying golden path, made him bear that damn prophecy, made him... almost lose her.

          Without a moment's hesitation, Paul struggled to his feet, walking unsteadily to the spice bags. He untied the ropes, plunging his hands into the fine, fragrant golden powder. Fragments of precognition scattered through his mind like startled bats, trying to stop him, showing countless miserable ways he might die without his powers. He grit his teeth, ignoring the churning visions.

          He took a deep breath, then with all his strength, he dragged the heavy bags and hurled them into the air!

          Golden dust exploded in the moonlight like a brief, brilliant rain. They had once been the keys to the most powerful force in the universe; now, they were just dust blown away by the wind, merging into the endless sea of sand. One bag, then another. Until all the spice they had painstakingly gathered, all the sources that could trigger his latent psychic potential, were completely discarded.

          He knelt in the sand, feeling something that had always been tense within him being drawn out as the spice vanished. The noisy echoes of the future and the past in his mind gradually weakened and finally fell silent. The world became simpler than ever before. Only the sound of the wind, the touch of the sand, the constant cold gaze of the stars in the night sky, and the steady breathing of Chani beside him remained.

          A massive, almost exhausting peace enveloped him. He returned to the survival blanket and lay down gently, pulling Chani's warm body into his arms. Her body heat seeped through the thin clothing, real and solid. He greedily breathed in the faint scent of desert plants and sweat in her hair; she was his anchor, the only reality he needed.

          He whispered, almost in a breath, to the ruthless desert, to the indifferent stars:

          “No more jihad. No more prophecy. No more Muad'Dib.”

          “I am just Paul. A man with you, Chani.”

          ***

          The first light of dawn, like a glowing knife, cut across the eastern horizon of Arrakis. The night chill fled rapidly, replaced by the scorching prelude of day's dominion over the earth.

          Chani woke before Paul. Fremen instinct allowed her to sense even the slightest environmental changes in her sleep. She opened her eyes, first seeing Paul's face close at hand. He was asleep, but his brow wasn't furrowed by dreams as usual; it was relaxed, showing a youthful peace she hadn't seen in a long time. His face was a bit pale, his lips slightly cracked.

          She moved gently, wanting to get up to prepare breakfast and check the moisture collector, but found Paul's arm still tightly around her, carrying a sense of undeniable possession and... dependence? She paused, then a trace of almost undetectable tenderness touched the corners of her mouth. She carefully, inch by inch, disentangled herself from his embrace without waking him.

          When she walked to the edge of the rocky shelter to check the bags of precious spice, her step faltered.

          The bags lay scattered on the ground, their mouths open. Inside, they were empty.

          The golden spice was gone; only on the surrounding sand could she faintly see some unnatural, glittering traces being blown away by the rising wind, quickly merging with the ordinary grains of sand.

          Her heart sank heavily. Spice was their only currency to trade for water, food, and supplies. Losing them in this vast and cruel desert meant survival would become immediately precarious. Who was it? Sand pirates? Or...

          Her gaze sharpened as she scanned the surroundings, her Fremen warrior alertness returned instantly. No unfamiliar tracks, no signs of a struggle. Only... Paul's footprints, extending from the sleeping area to the spice bags, messy and deep.

          She walked back to the sleeping Paul and knelt down, watching him closely. No outside enemy. Then, it could only be him.

          Why?

          The question weighed on her mind like a stone. She didn't immediately wake him to interrogate him. Chani just silently stood up and began to deal with the situation in the Fremen way. She carefully folded the empty bags; every scrap of cloth could save a life in the desert. She checked their water reserve, calculating how long they could last without new supplies. She wiped and maintained her crysknife, her movements skilled and steady.

          When Paul was finally awakened by the increasingly hot sunlight, he saw Chani had already started a small, low-oxygen fire to heat food, with a kettle over it. Her figure looked slightly blurred in the rising heat waves, but her movements were still so elegant and efficient.

          “You're awake.” Chani heard the sound and turned her head, her voice calm and flat. She handed him a canteen filled with concentrated nutrient fluid, “Drink some.”

          Paul took it and took a sip. The liquid had a faint, not-so-pleasant chemical taste but could quickly replenish energy. He noticed Chani didn't ask about the spice. She knew. He met her gaze; in those deep eyes, he saw worry and doubt, but no accusation, no heartbreaking curse from his dream.

          “Chani,” he began, his voice raspy from sleep, “I...”

          “Eat first,” Chani interrupted him, her tone gentle but firm, “after the sun is fully up, the sand will be too hot to walk on. We need to plan today's route.”

          She didn't ask. She gave him space and gave herself time to digest. This was Chani's way.

          They finished their simple breakfast in silence. While packing their gear, Paul finally couldn't stand the silence anymore.

          “I threw away the spice,” he said directly, his voice not loud but like a stone thrown into a still pond.

          Chani didn't stop folding the survival blanket, just let out a quiet “Mm” to show she was listening.

          “I had a dream...” Paul tried to describe it, but found the sea of blood and the curse seemed so absurd under the real sun, yet it was so real in how it gnawed at him. “A... very bad dream. I saw... if I kept going down that path, I would lose you. Lose everything.” He omitted the specific details, the ninety billion dead, the curse of “forgetting how to be a human.” Those were too heavy, too insane.

          He looked up, his eyes burning as he watched her: “I can't be that, Chani. I can't become... the one in my dream. Spice, precognition... they are a chain dragging me in that direction. I had to break it.”

          Chani stopped what she was doing, turned, and faced him fully. Her gaze searched his face, like reading a complex and ancient scroll. She saw the lingering terror in his eyes, the resolve in his tone, and the deep value he placed on her and their life.

          A long silence. Only the sound of the wind.

          Then, Chani stepped forward, reaching out not to hug him, but to gently brush away some sand from his shoulder.

          “Without spice, life will be very hard, Paul.” Her voice was soft but exceptionally clear, “Fremen know that in the desert, survival comes first. Every decision has a price.”

          She didn't say “I support you,” nor did she say “you're wrong.” She just stated a cold fact.

          “But,” she changed her tone slightly, her eyes softening, “if you think it's necessary... then we will face the hardship together.”

          She took his hand. Her palm was coarse from years of labor, but warm and strong.

          “From now on, we're just spice haulers. Two ordinary Fremen.” she paused, then added, “Or, at least we'll try to be.”

          Hope, like a small water source found accidentally in the desert, seeped through Paul's parched heart. He squeezed her hand back and nodded firmly.

          They started the old spice harvester, its engine letting out a dull, strained roar that sounded particularly harsh in the empty desert. The large machine moved slowly, its tracks rolling over the dunes, leaving two deep ruts that were soon quietly buried by the wind and sand.

          Paul sat in the cockpit, clumsily operating the control levers. Without his precognitive help, he felt like a half-blind man, having to rely on basic instruments and his own sight to judge the direction and avoid pits. Every bump, every abnormal sound from the engine made his heart tighten.

          Chani sat beside him, focused on the map spread on her knees, drawn on tanned animal skin. Her fingers moved slowly across it, occasionally looking up to compare the distant rocky terrain and the sun's position.

          “That way,” she pointed to a faintly visible rocky hill that looked like a camel's back, “according to the map and ancestral legends, that area long ago, before the Harkonnens stripped the land like locusts, had shallow spice veins. Maybe... some is left.”

          Her voice was calm, but Paul could hear the uncertainty. Legends, remains. These were slim hopes. Without precognition, they were like a ship without navigation, only able to feel their way through the vast desert based on experience and luck.

          Daytime Arrakis was a purgatory. The sun poured down without obstacle, baking the sand till it was scalding, the heat waves distorting distant objects. The clunky air conditioning inside the harvester was old and ineffective, the heat stifling. Every time they stepped out for field inspections, it was like entering a giant furnace.

          Paul, along with other recruited haulers, dug, sampled, and hauled with heavy tools. Sweat evaporated as soon as it left his pores, leaving white salt stains. Muscles ached, his lungs breathed in the scorching air with that uniquely sweet, dizzying scent of spice—but now, that scent no longer brought shadows of the future, only the near-total exhaustion of physical labor.

          During breaks, he sat in a patch of shade, drinking his strictly rationed water. Nearby, several old Fremen workers were talking quietly, their voices carried by the wind.

          “...Heard the 'outer rim' is getting unsettled again. The Guild raised the shipping tax, says routes are being harassed...”

          “Who else? Must be those fanatics calling themselves 'Muad'Dib's followers.' Using the Savior's name to raid Noble transport ships everywhere.”

          “Savior? Hmph, he's been gone so long, left a mess. I heard the Emperor and the Guild big shots have raised the bounty again. Alive or dead. Tsk, that price could buy half the water on Arrakis!”

          “Quiet! You want to die? Who knows...”

          The voices dropped, full of caution.

          Paul kept his head down, pretending not to hear, but his knuckles went white on his canteen. Muad'Dib... the name was like a ghost that still haunted him even after his self-exile. His “followers” were starting wars in his name, and the universe was more chaotic because of his disappearance. And he himself was here, for basic survival, dragging his exhausted body to dig for spice that might not even exist.

          A deep sense of powerlessness seized him. Having abandoned his divine power, he seemed to have also lost the ability to change anything. Was this path he chose really right? Just to be with Chani, while ignoring the conflicts he caused—wasn't that another form of “forgetting how to be a human”?

          He looked up, toward Chani who was using precise instruments to analyze sand samples in the distance. Her back swayed slightly in the heat waves, but she stood straight, with that unique Fremen resilience that never yielded even in despair.

          For her. He repeated to himself. To keep the curse in his dream from coming true.

          Just then, a sharp engine whine came from the harvester, breaking his thoughts. Then came the harsh sound of metal snapping and a thick cloud of black smoke.

          Paul and the workers ran over. Loken, the old engineer in charge of power, crawled out of the maintenance hatch, his face covered in grease and coughing.

          “It's gone!” he slapped the metal casing beside him in frustration, “Main driveshaft snapped! Damned Harkonnen junk! We don't have the spare parts for this!”

          A stir went through the group. In this deep desert, far from any settlement, a dead machine meant death. Without it, they couldn't move quickly, couldn't gather effectively, and couldn't face any sandstorms or... worms.

          Despair began to spread.

          Paul looked at the smoking behemoth, feeling like it was a mirror of his own situation—paralyzed, helpless, trapped in this golden desert.

          Chani, who had been silently checking the damage, suddenly straightened. She didn't look at the anxious workers but turned her sharp gaze toward that distant “camel back” rock area.

          “The machine is broken, but we still have hands, feet, and the wisdom of our Fremen ancestors.” Her voice wasn't loud, but it clearly carried over the noise, “Loken, take two men and strip what parts you can, especially the water recycling and the comms.”

          She turned to Paul, and as their eyes met, Paul saw the undeniable determination in her gaze.

          “Paul, you and I, we're going to that rock area.” she pointed away, “Not just for spice. Ancient Fremen shelters were often built near spice veins. There, we might find things we need—tools, and maybe... water.”

          No precognition, no divine power, only the most primitive survival instinct and mutual trust.

          Paul breathed in the scorching air and nodded.

          “Okay.”

          Night fell again, and the temperature dropped sharply. Paul and Chani, with simple packs on their backs, trudged through the cold dunes, moving toward the black silhouette of the rock area under the starlight. The twin moons stretched their shadows long, very long, casting them over the lonely sea of sand.

          And at a height they couldn't perceive, in synchronous orbit, a small surveillance ship without any family crest pointed its precise sensors at this vast desert. At the center of the sensor's feedback were two tiny but exceptionally clear heat signatures, moving slowly but steadily.
        role: user
      description: ''
      context_window: 0
    - id: B
      type: agent
      config:
        name: gpt-4o
        provider: openai
        role: Please summarize the content of the novel.
        base_url: ${BASE_URL}
        api_key: ${API_KEY}
        params: {}
        tooling: []
        thinking: null
        memories: []
        retry: null
      description: ''
      context_window: 0
  edges:
    - from: A
      to: B
      trigger: true
      condition: 'true'
      carry_data: true
      keep_message: false
      clear_context: false
      clear_kept_context: false
      process: null
      dynamic:
        type: tree
        split:
          type: regex
          config:
            pattern: (?s).{1,2000}(?:\\s|$)
        config:
          group_size: 3
          max_parallel: 10
  memory: []
  initial_instruction: ''
  start:
    - A
  end: []
version: 0.0.0
vars: {}
